diff --git a/src/main/java/net/minecraft/client/gui/GuiEditFlag.java b/src/main/java/net/minecraft/client/gui/container/FlagEditorScreen.java
similarity index 70%
rename from src/main/java/net/minecraft/client/gui/GuiEditFlag.java
rename to src/main/java/net/minecraft/client/gui/container/FlagEditorScreen.java
index 1cd9941da..46346e755 100644
--- a/src/main/java/net/minecraft/client/gui/GuiEditFlag.java
+++ b/src/main/java/net/minecraft/client/gui/container/FlagEditorScreen.java
@@ -1,5 +1,9 @@
-package net.minecraft.client.gui;
+package net.minecraft.client.gui.container;
 
+import net.minecraft.client.gui.ButtonElement;
+import net.minecraft.client.gui.ClickableLabelElement;
+import net.minecraft.client.gui.DrawableSurfaceElement;
+import net.minecraft.client.gui.TexturedButtonElement;
 import net.minecraft.core.block.entity.FlagBlockEntity;
 import net.minecraft.core.entity.player.Player;
 import org.lwjgl.input.Keyboard;
@@ -16,8 +20,8 @@ import net.minecraft.core.net.packet.CustomPayloadPacket;
 import net.minecraft.core.player.inventory.menu.FlagMenu;
 import net.minecraft.core.util.helper.MathHelper;
 
-public class GuiEditFlag
-    extends GuiContainer
+public class FlagEditorScreen
+    extends AbstractContainerScreen
     implements IDrawableSurface<Byte>
 {
     private final FlagBlockEntity tileEntity;
@@ -33,28 +37,28 @@ public class GuiEditFlag
     private int canvasX = 0;
     private int canvasY = 0;
     private int selectedColor = 0;
-    private GuiClickableLabel[] colorLabels;
+    private ClickableLabelElement[] colorLabels;
 
     private final DrawableEditor<Byte> flagSurfaceEditor;
     private final DrawableEditor<Byte> drawOverlaySurfaceEditor;
 
-    private GuiTexturedButton[] toolBtns;
+    private TexturedButtonElement[] toolBtns;
     private int activeTool = 0;
 
-    GuiSurface flagSurface;
-    GuiSurface drawOverlaySurface;
+    DrawableSurfaceElement flagSurface;
+    DrawableSurfaceElement drawOverlaySurface;
     
-    public GuiEditFlag(Player player, FlagBlockEntity flagTileEntity)
+    public FlagEditorScreen(Player player, FlagBlockEntity flagTileEntity)
     {
         super(new FlagMenu(player.inventory, flagTileEntity));
         this.tileEntity = flagTileEntity;
         xSize = 176;
         ySize = 195;
-        flagTileEntity.owner = player.username;
+        flagTileEntity.owner = player.uuid;
 
-        flagSurface = new GuiSurface(CANVAS_WIDTH, CANVAS_HEIGHT, CANVAS_SCALE, flagTileEntity.flagColors);
+        flagSurface = new DrawableSurfaceElement(CANVAS_WIDTH, CANVAS_HEIGHT, CANVAS_SCALE, flagTileEntity.flagColors);
         flagSurfaceEditor = new DrawableEditor<>(flagSurface);
-        drawOverlaySurface = new GuiSurface(CANVAS_WIDTH, CANVAS_HEIGHT, CANVAS_SCALE);
+        drawOverlaySurface = new DrawableSurfaceElement(CANVAS_WIDTH, CANVAS_HEIGHT, CANVAS_SCALE);
         drawOverlaySurfaceEditor = new DrawableEditor<>(drawOverlaySurface);
     }
 
@@ -62,30 +66,30 @@ public class GuiEditFlag
     public void init()
     {
         super.init();
-        controlList.clear();
+        buttons.clear();
 
         canvasX = (width - xSize) / 2 + 27;
         canvasY = (height - ySize) / 2 + 8;
 
-        toolBtns = new GuiTexturedButton[7];
+        toolBtns = new TexturedButtonElement[7];
 
         for (int i = 0; i < 7; i++)
         {
-            toolBtns[i] = new GuiTexturedButton(i, "/assets/minecraft/textures/gui/container/flag_editor.png", (width - xSize) / 2 + 12 + 22 * i, (height - ySize) / 2 + 76, 20 * i, 195, 20, 20);
+            toolBtns[i] = new TexturedButtonElement(i, "/assets/minecraft/textures/gui/container/flag_editor.png", (width - xSize) / 2 + 12 + 22 * i, (height - ySize) / 2 + 76, 20 * i, 195, 20, 20);
             if (i == activeTool) toolBtns[i].enabled = false;
-            controlList.add(toolBtns[i]);
+            buttons.add(toolBtns[i]);
         }
 
-        colorLabels = new GuiClickableLabel[3];
+        colorLabels = new ClickableLabelElement[3];
 
         for (int i = 0; i < 3; i++)
         {
-            colorLabels[i] = new GuiClickableLabel(100 + i, (width - xSize) / 2 + 150, (height - ySize) / 2 + 12 + (i * 22), String.valueOf(i + 1), 0xFFFFFFFF, 0x00000000);
+            colorLabels[i] = new ClickableLabelElement(100 + i, (width - xSize) / 2 + 150, (height - ySize) / 2 + 12 + (i * 22), String.valueOf(i + 1), 0xFFFFFFFF, 0x00000000);
             if (i != selectedColor) {
-                colorLabels[i].textColor = 0xFF3F3F3F;
-                colorLabels[i].shadow = false;
+                colorLabels[i].setTextColor(0xFF3F3F3F);
+                colorLabels[i].setShadow(false);
             }
-            controlList.add(colorLabels[i]);
+            buttons.add(colorLabels[i]);
         }
     }
 
@@ -115,9 +119,9 @@ public class GuiEditFlag
     }
 
     @Override
-    public void mouseClicked(int mouseX, int mouseY, int mouseButton)
+    public void mouseClicked(int mx, int my, int buttonNum)
     {
-        super.mouseClicked(mouseX, mouseY, mouseButton);
+        super.mouseClicked(mx, my, buttonNum);
         
         // Do not draw with no color selected
         if(tileEntity.getItem(36 + selectedColor) == null) {
@@ -128,15 +132,15 @@ public class GuiEditFlag
         {
             if (!isDrawing)
             {
-                int xInCanvas = (mouseX - canvasX) / CANVAS_SCALE;
-                int yInCanvas = (mouseY - canvasY) / CANVAS_SCALE;
+                int xInCanvas = (mx - canvasX) / CANVAS_SCALE;
+                int yInCanvas = (my - canvasY) / CANVAS_SCALE;
                 if (xInCanvas >= 0 && xInCanvas < CANVAS_WIDTH
                         && yInCanvas >= 0 && yInCanvas < CANVAS_HEIGHT)
                 {
                     isDrawing = true;
                     xLast = xInCanvas;
                     yLast = yInCanvas;
-                    this.mouseButton = mouseButton;
+                    this.mouseButton = buttonNum;
 
                     byte color = 0;
                     if (this.mouseButton == 0)
@@ -151,13 +155,13 @@ public class GuiEditFlag
         {
             if (!isDrawing)
             {
-                int xInCanvas = (mouseX - canvasX) / CANVAS_SCALE;
-                int yInCanvas = (mouseY - canvasY) / CANVAS_SCALE;
+                int xInCanvas = (mx - canvasX) / CANVAS_SCALE;
+                int yInCanvas = (my - canvasY) / CANVAS_SCALE;
                 if (xInCanvas >= 0 && xInCanvas < CANVAS_WIDTH
                         && yInCanvas >= 0 && yInCanvas < CANVAS_HEIGHT)
                 {
                     isDrawing = true;
-                    this.mouseButton = mouseButton;
+                    this.mouseButton = buttonNum;
 
                     byte color = 0;
                     if (this.mouseButton == 0)
@@ -172,13 +176,13 @@ public class GuiEditFlag
         {
             if (!isDrawing)
             {
-                int xInCanvas = (mouseX - canvasX) / CANVAS_SCALE;
-                int yInCanvas = (mouseY - canvasY) / CANVAS_SCALE;
+                int xInCanvas = (mx - canvasX) / CANVAS_SCALE;
+                int yInCanvas = (my - canvasY) / CANVAS_SCALE;
                 if (xInCanvas >= 0 && xInCanvas < CANVAS_WIDTH
                         && yInCanvas >= 0 && yInCanvas < CANVAS_HEIGHT)
                 {
                     isDrawing = true;
-                    this.mouseButton = mouseButton;
+                    this.mouseButton = buttonNum;
 
                     xLast = xInCanvas;
                     yLast = yInCanvas;
@@ -188,9 +192,9 @@ public class GuiEditFlag
     }
 
     @Override
-    protected void buttonPressed(GuiButton button)
+    protected void buttonClicked(ButtonElement button)
     {
-        super.buttonPressed(button);
+        super.buttonClicked(button);
         if (button.id >= 0 && button.id < 7)
         {
             toolBtns[activeTool].enabled = true;
@@ -199,22 +203,22 @@ public class GuiEditFlag
         }
         if (button.id >= 100 && button.id < 103)
         {
-            colorLabels[selectedColor].textColor = 0xFF404040;
-            colorLabels[selectedColor].shadow = false;
+            colorLabels[selectedColor].setTextColor(0xFF404040);
+            colorLabels[selectedColor].setShadow(false);
             selectedColor = button.id - 100;
-            colorLabels[selectedColor].textColor = 0xFFFFFFFF;
-            colorLabels[selectedColor].shadow = true;
+            colorLabels[selectedColor].setTextColor(0xFFFFFFF);
+            colorLabels[selectedColor].setShadow(true);
         }
     }
 
     @Override
-    public void mouseMovedOrButtonReleased(final int mouseX, final int mouseY, final int mouseButton)
+    public void mouseReleased(final int mx, final int my, final int buttonNum)
     {
-        super.mouseMovedOrButtonReleased(mouseX, mouseY, mouseButton);
+        super.mouseReleased(mx, my, buttonNum);
 
         if (activeTool >= 0 && activeTool < 3) // Pen
         {
-            if (isDrawing && mouseButton != -1)
+            if (isDrawing && buttonNum != -1)
             {
                 isDrawing = false;
                 this.mouseButton = -1;
@@ -222,8 +226,8 @@ public class GuiEditFlag
             else if (isDrawing)
             {
                 // divide by pixel scale
-                int xInCanvas = (mouseX - canvasX) / CANVAS_SCALE;
-                int yInCanvas = (mouseY - canvasY) / CANVAS_SCALE;
+                int xInCanvas = (mx - canvasX) / CANVAS_SCALE;
+                int yInCanvas = (my - canvasY) / CANVAS_SCALE;
 
                 byte color = 0;
                 if (this.mouseButton == 0)
@@ -246,7 +250,7 @@ public class GuiEditFlag
         }
         else if (activeTool == 3) // Flood fill
         {
-            if (isDrawing && mouseButton != -1)
+            if (isDrawing && buttonNum != -1)
             {
                 isDrawing = false;
                 this.mouseButton = -1;
@@ -254,13 +258,13 @@ public class GuiEditFlag
         }
         else if (activeTool == 4) // Rectangle
         {
-            if (isDrawing && mouseButton != -1)
+            if (isDrawing && buttonNum != -1)
             {
                 isDrawing = false;
 
                 // divide by pixel scale
-                int xInCanvas = (mouseX - canvasX) / CANVAS_SCALE;
-                int yInCanvas = (mouseY - canvasY) / CANVAS_SCALE;
+                int xInCanvas = (mx - canvasX) / CANVAS_SCALE;
+                int yInCanvas = (my - canvasY) / CANVAS_SCALE;
 
                 byte color = 0;
                 if (this.mouseButton == 0)
@@ -274,13 +278,13 @@ public class GuiEditFlag
         }
         else if (activeTool == 5) // Ellipse
         {
-            if (isDrawing && mouseButton != -1)
+            if (isDrawing && buttonNum != -1)
             {
                 isDrawing = false;
 
                 // divide by pixel scale
-                int xInCanvas = (mouseX - canvasX) / CANVAS_SCALE;
-                int yInCanvas = (mouseY - canvasY) / CANVAS_SCALE;
+                int xInCanvas = (mx - canvasX) / CANVAS_SCALE;
+                int yInCanvas = (my - canvasY) / CANVAS_SCALE;
 
                 byte color = 0;
                 if (this.mouseButton == 0)
@@ -294,13 +298,13 @@ public class GuiEditFlag
         }
         else if (activeTool == 6) // Line
         {
-            if (isDrawing && mouseButton != -1)
+            if (isDrawing && buttonNum != -1)
             {
                 isDrawing = false;
 
                 // divide by pixel scale
-                int xInCanvas = (mouseX - canvasX) / CANVAS_SCALE;
-                int yInCanvas = (mouseY - canvasY) / CANVAS_SCALE;
+                int xInCanvas = (mx - canvasX) / CANVAS_SCALE;
+                int yInCanvas = (my - canvasY) / CANVAS_SCALE;
 
                 byte color = 0;
                 if (this.mouseButton == 0)
@@ -318,7 +322,7 @@ public class GuiEditFlag
     protected void drawGuiContainerBackgroundLayer(float f) 
     {
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-        mc.renderEngine.loadTexture("/assets/minecraft/textures/gui/container/flag_editor.png").bind();
+        mc.textureManager.loadTexture("/assets/minecraft/textures/gui/container/flag_editor.png").bind();
         int j = (width - xSize) / 2;
         int k = (height - ySize) / 2;
         drawTexturedModalRect(j, k, 0, 0, xSize, ySize);
@@ -326,13 +330,13 @@ public class GuiEditFlag
     }
 
     @Override
-    public void drawScreen(int mouseX, int mouseY, float partialTick)
+    public void render(int xm, int ym, float partialTick)
     {
-        super.drawScreen(mouseX, mouseY, partialTick);
+        super.render(xm, ym, partialTick);
         drawOverlaySurface.clear();
 
-        int xInCanvas = (mouseX - canvasX) / CANVAS_SCALE;
-        int yInCanvas = (mouseY - canvasY) / CANVAS_SCALE;
+        int xInCanvas = (xm - canvasX) / CANVAS_SCALE;
+        int yInCanvas = (ym - canvasY) / CANVAS_SCALE;
         byte color = (byte) (selectedColor + 1);
         if (this.mouseButton == 1) color = 4;
 
@@ -383,13 +387,13 @@ public class GuiEditFlag
 
     @Override
     protected void drawGuiContainerForegroundLayer() {
-        fontRenderer.drawString(I18n.getInstance().translateKey("gui.edit_flag.label.inventory"), 8, (ySize - 96) + 2, 0xFF404040);
+        font.drawString(I18n.getInstance().translateKey("gui.edit_flag.label.inventory"), 8, (ySize - 96) + 2, 0xFF404040);
     }
 
     @Override
-    public void keyTyped(char c, int keyCode, int mouseX, int mouseY) 
+    public void keyPressed(char eventCharacter, int eventKey, int mx, int my)
     {
-        if (keyCode == Keyboard.KEY_ESCAPE || mc.gameSettings.keyInventory.isKeyboardKey(keyCode) || keyCode == Keyboard.KEY_BACK)
+        if (eventKey == Keyboard.KEY_ESCAPE || mc.gameSettings.keyInventory.isKeyboardKey(eventKey) || eventKey == Keyboard.KEY_BACK)
         {
     		// Flag packet needs to be sent before the close screen packet is sent!
     		if(mc.theWorld.isClientSide) {
@@ -398,15 +402,15 @@ public class GuiEditFlag
             mc.thePlayer.closeScreen();
         }
 
-        if (keyCode == Keyboard.KEY_1 || keyCode == Keyboard.KEY_2 || keyCode == Keyboard.KEY_3) {
-            colorLabels[selectedColor].textColor = 0xFF404040;
-            colorLabels[selectedColor].shadow = false;
-            selectedColor = keyCode - Keyboard.KEY_1;
-            colorLabels[selectedColor].textColor = 0xFFFFFFFF;
-            colorLabels[selectedColor].shadow = true;
+        if (eventKey == Keyboard.KEY_1 || eventKey == Keyboard.KEY_2 || eventKey == Keyboard.KEY_3) {
+            colorLabels[selectedColor].setTextColor(0xFF404040);
+            colorLabels[selectedColor].setShadow(false);
+            selectedColor = eventKey - Keyboard.KEY_1;
+            colorLabels[selectedColor].setTextColor(0xFFFFFFFF);
+            colorLabels[selectedColor].setShadow(true);
 
         }
-        super.keyTyped(c, keyCode, mouseX, mouseY);
+        super.keyPressed(eventCharacter, eventKey, mx, my);
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/client/gui/GuiFurnace.java b/src/main/java/net/minecraft/client/gui/container/FurnaceScreen.java
similarity index 73%
rename from src/main/java/net/minecraft/client/gui/GuiFurnace.java
rename to src/main/java/net/minecraft/client/gui/container/FurnaceScreen.java
index 325ea10d7..ba4e905d4 100644
--- a/src/main/java/net/minecraft/client/gui/GuiFurnace.java
+++ b/src/main/java/net/minecraft/client/gui/container/FurnaceScreen.java
@@ -1,4 +1,4 @@
-package net.minecraft.client.gui;
+package net.minecraft.client.gui.container;
 
 import net.minecraft.client.input.controller.ControllerInput;
 import net.minecraft.core.block.entity.BlastFurnaceBlockEntity;
@@ -8,10 +8,10 @@ import net.minecraft.core.player.inventory.menu.FurnaceMenu;
 import net.minecraft.core.player.inventory.container.Inventory;
 import org.lwjgl.opengl.GL11;
 
-public class GuiFurnace extends GuiContainer
+public class FurnaceScreen extends AbstractContainerScreen
 {
 
-    public GuiFurnace(Inventory inventoryplayer, FurnaceBlockEntity tileentityfurnace)
+    public FurnaceScreen(Inventory inventoryplayer, FurnaceBlockEntity tileentityfurnace)
     {
         super(new FurnaceMenu(inventoryplayer, tileentityfurnace));
         furnaceInventory = tileentityfurnace;
@@ -22,20 +22,20 @@ public class GuiFurnace extends GuiContainer
     {
         I18n i18n = I18n.getInstance();
         if(furnaceInventory instanceof BlastFurnaceBlockEntity) {
-            fontRenderer.drawString(i18n.translateKey("gui.furnace.blast.label.blast_furnace"), 60, 6, 0x404040);
+            font.drawString(i18n.translateKey("gui.furnace.blast.label.blast_furnace"), 60, 6, 0x404040);
         } else {
-            fontRenderer.drawString(i18n.translateKey("gui.furnace.label.furnace"), 60, 6, 0x404040);
+            font.drawString(i18n.translateKey("gui.furnace.label.furnace"), 60, 6, 0x404040);
         }
-        fontRenderer.drawString(i18n.translateKey("gui.furnace.label.inventory"), 8, (ySize - 96) + 2, 0x404040);
+        font.drawString(i18n.translateKey("gui.furnace.label.inventory"), 8, (ySize - 96) + 2, 0x404040);
     }
 
     @Override
 	protected void drawGuiContainerBackgroundLayer(float f)
     {
         if(furnaceInventory instanceof BlastFurnaceBlockEntity) {
-            mc.renderEngine.loadTexture("/assets/minecraft/textures/gui/container/blastfurnace.png").bind();
+            mc.textureManager.loadTexture("/assets/minecraft/textures/gui/container/blastfurnace.png").bind();
         } else {
-            mc.renderEngine.loadTexture("/assets/minecraft/textures/gui/container/furnace.png").bind();
+            mc.textureManager.loadTexture("/assets/minecraft/textures/gui/container/furnace.png").bind();
         }
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
         int x = (width - xSize) / 2;
@@ -59,7 +59,7 @@ public class GuiFurnace extends GuiContainer
     }
     @Override
     public void guiSpecificControllerInput(ControllerInput controller){
-        controller.craftingGuiHandler.handleFurnace(this);
+        controller.inventoryHandler.handleFurnace(this);
     }
 
     private final FurnaceBlockEntity furnaceInventory;
diff --git a/src/main/java/net/minecraft/client/gui/GuiInventory.java b/src/main/java/net/minecraft/client/gui/container/InventoryScreen.java
similarity index 78%
rename from src/main/java/net/minecraft/client/gui/GuiInventory.java
rename to src/main/java/net/minecraft/client/gui/container/InventoryScreen.java
index 17c899895..656915880 100644
--- a/src/main/java/net/minecraft/client/gui/GuiInventory.java
+++ b/src/main/java/net/minecraft/client/gui/container/InventoryScreen.java
@@ -1,11 +1,14 @@
-package net.minecraft.client.gui;
+package net.minecraft.client.gui.container;
 
 import static org.lwjgl.opengl.GL11.*;
 
 import java.util.ArrayList;
 import java.util.List;
 
-import net.minecraft.client.gui.options.GuiOptionButton;
+import net.minecraft.client.gui.ButtonElement;
+import net.minecraft.client.gui.GuiElement;
+import net.minecraft.client.gui.ListLayout;
+import net.minecraft.client.gui.options.OverlayButtonElement;
 import net.minecraft.client.input.controller.ControllerInput;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.core.achievement.Achievements;
@@ -30,10 +33,10 @@ import org.lwjgl.opengl.GL12;
 //            RenderEngine, LocalPlayer, RenderHelper, RenderManager,
 //            GuiButton, GuiAchievements, GuiStats
 
-public class GuiInventory extends GuiContainer
+public class InventoryScreen extends AbstractContainerScreen
 {
 	
-	private GuiButton armorButton;
+	private ButtonElement armorButton;
     protected int armourValuesFloat = 130;
     protected int armourButtonFloatX = 20;
 	protected ListLayout overlayButtonsLayout = new ListLayout(this).setAlign(0.5, 0.5).setVertical(false).setElementSize(11, 11).setOffset(-(xSize / 2), -(ySize / 2) - 10).setMargin(1);
@@ -41,23 +44,23 @@ public class GuiInventory extends GuiContainer
 	
 	private DamageType hoveredDamageType;
 
-    public GuiInventory(Player player)
+    public InventoryScreen(Player player)
     {
         super(player.inventorySlots);
-        allowIngameInput = true;
+        passEvents = true;
         player.addStat(Achievements.OPEN_INVENTORY, 1);
     }
 
     @Override
 	public void init()
     {
-        controlList.clear();
+        buttons.clear();
 
 
-        armorButton = new GuiButton(100, width / 2 - armourButtonFloatX, height / 2 - 74, 9, 9, "");
+        armorButton = new ButtonElement(100, width / 2 - armourButtonFloatX, height / 2 - 74, 9, 9, "");
         armorButton.visible = false;
         checkForArmor();
-        controlList.add(armorButton);
+        buttons.add(armorButton);
 
 		updateOverlayButtons();
     }
@@ -112,57 +115,57 @@ public class GuiInventory extends GuiContainer
         overlayButtonsLayout.elements.clear();
         
         if(compass) {
-        	overlayButtonsLayout.addElement(new GuiOptionButton<>(settings, settings.overlayShowCoords));
+        	overlayButtonsLayout.addElement(new OverlayButtonElement<>(settings, settings.overlayShowCoords));
         	uvs.add(0);
-        	overlayButtonsLayout.addElement(new GuiOptionButton<>(settings, settings.overlayShowDirection));
+        	overlayButtonsLayout.addElement(new OverlayButtonElement<>(settings, settings.overlayShowDirection));
         	uvs.add(1);
         }
         if(clock) {
-        	overlayButtonsLayout.addElement(new GuiOptionButton<>(settings, settings.overlayShowTime));
+        	overlayButtonsLayout.addElement(new OverlayButtonElement<>(settings, settings.overlayShowTime));
         	uvs.add(2);
         }
         if(rotaryCalendar) {
-        	overlayButtonsLayout.addElement(new GuiOptionButton<>(settings, settings.overlayShowSeason));
+        	overlayButtonsLayout.addElement(new OverlayButtonElement<>(settings, settings.overlayShowSeason));
         	uvs.add(3);
-        	overlayButtonsLayout.addElement(new GuiOptionButton<>(settings, settings.overlayShowWeather));
+        	overlayButtonsLayout.addElement(new OverlayButtonElement<>(settings, settings.overlayShowWeather));
         	uvs.add(4);
-        	overlayButtonsLayout.addElement(new GuiOptionButton<>(settings, settings.overlayShowBiome));
+        	overlayButtonsLayout.addElement(new OverlayButtonElement<>(settings, settings.overlayShowBiome));
         	uvs.add(5);
         }
         
         overlayButtonsLayout.updateElementPositions();
         
         for (GuiElement element : overlayButtonsLayout.elements) {
-    		GuiButton button = (GuiButton) element;
+    		ButtonElement button = (ButtonElement) element;
     		button.visible = false;
-    		controlList.add(button);
+    		buttons.add(button);
         }
     }
 
     @Override
 	protected void drawGuiContainerForegroundLayer()
     {
-        fontRenderer.drawString(I18n.getInstance().translateKey("gui.inventory.label.crafting"), 86, 16, 0x404040);
+        font.drawString(I18n.getInstance().translateKey("gui.inventory.label.crafting"), 86, 16, 0x404040);
     }
 
     @Override
-	public void drawScreen(int mouseX, int mouseY, float partialTick)
+	public void render(int xm, int ym, float partialTick)
     {
-        super.drawScreen(mouseX, mouseY, partialTick);
-        xSize_lo = mouseX;
-        ySize_lo = mouseY;
+        super.render(xm, ym, partialTick);
+        xSize_lo = xm;
+        ySize_lo = ym;
 
         if(mc.gameSettings.armorProtectionOverlay.value && armorButton.enabled) {
-        	drawProtectionOverlay(mouseX, mouseY);
+        	drawProtectionOverlay(xm, ym);
         }
-        mc.renderEngine.loadTexture("/assets/minecraft/textures/gui/container/inventory.png").bind();
+        mc.textureManager.loadTexture("/assets/minecraft/textures/gui/container/inventory.png").bind();
         
         glColor4d(1.0, 1.0, 1.0, 1.0);
         glDisable(GL_BLEND);
         glEnable(GL_TEXTURE_2D);
         
         if(armorButton.enabled) {
-            if(armorButton.isHovered(mouseX, mouseY)) {
+            if(armorButton.isHovered(xm, ym)) {
             	drawTexturedModalRect(armorButton.xPosition, armorButton.yPosition, 185, 0, armorButton.width, armorButton.height);
             }else {
             	drawTexturedModalRect(armorButton.xPosition, armorButton.yPosition, 176, 0, armorButton.width, armorButton.height);
@@ -170,7 +173,7 @@ public class GuiInventory extends GuiContainer
         }
         
         for(int i=0; i < overlayButtonsLayout.elements.size(); i++) {
-        	GuiOptionButton<?> button = (GuiOptionButton<?>) overlayButtonsLayout.elements.get(i);
+        	OverlayButtonElement<?> button = (OverlayButtonElement<?>) overlayButtonsLayout.elements.get(i);
         	drawTexturedModalRect(button.xPosition + 1, button.yPosition + 1, 176, 9 + 9 * uvs.get(i), 9, 9);
         	boolean val = true;
         	if(button.option instanceof BooleanOption) val = (Boolean) button.option.value;
@@ -178,10 +181,10 @@ public class GuiInventory extends GuiContainer
         }
 
         for(int i=0; i < overlayButtonsLayout.elements.size(); i++) {
-        	GuiOptionButton<?> button = (GuiOptionButton<?>) overlayButtonsLayout.elements.get(i);
-        	if(button.isHovered(mouseX, mouseY))
+        	OverlayButtonElement<?> button = (OverlayButtonElement<?>) overlayButtonsLayout.elements.get(i);
+        	if(button.isHovered(xm, ym))
             {
-                guiTooltip.render(button.option.getDisplayStringName() + ": " + button.displayString, mouseX, mouseY, 8, -8);
+                tooltipElement.render(button.option.getDisplayStringName() + ": " + button.displayString, xm, ym, 8, -8);
         	}
         }
         
@@ -249,7 +252,7 @@ public class GuiInventory extends GuiContainer
 
         	String str = I18n.getInstance().translateKey(hoveredDamageType.getLanguageKey()) + ":\n" + protection + " / 100";
         	
-        	guiTooltip.render(str, mouseX, mouseY, 8, -8);
+        	tooltipElement.render(str, mouseX, mouseY, 8, -8);
         }
     }
 
@@ -257,7 +260,7 @@ public class GuiInventory extends GuiContainer
 	protected void drawGuiContainerBackgroundLayer(float f)
     {
         GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
-        mc.renderEngine.loadTexture("/assets/minecraft/textures/gui/container/inventory.png").bind();
+        mc.textureManager.loadTexture("/assets/minecraft/textures/gui/container/inventory.png").bind();
         int j = (width - xSize) / 2;
         int k = (height - ySize) / 2;
         drawTexturedModalRect(j, k, 0, 0, xSize, ySize);
@@ -295,7 +298,7 @@ public class GuiInventory extends GuiContainer
     }
 
     @Override
-	protected void buttonPressed(GuiButton button)
+	protected void buttonClicked(ButtonElement button)
     {
         if (button == armorButton) {
         	mc.gameSettings.armorProtectionOverlay.toggle();
@@ -304,7 +307,7 @@ public class GuiInventory extends GuiContainer
 
     @Override
     public void guiSpecificControllerInput(ControllerInput controller){
-        controller.craftingGuiHandler.handleInventory(this);
+        controller.inventoryHandler.handleInventory(this);
     }
 
     protected float xSize_lo;
